// removeSegment.cc $Lastupdate: 2009-01-29 $

// ver.1.5 2009.01.29 ƻǡ1ܤݤƤ顼ƣ
// ver.1.4 2007.12.07 PF2 βƻǡϤ褦ˤΩ

#include <iostream>        // changed from *.h on Oct. 11, 2007
#include <fstream>         // changed from *.h on Oct. 11, 2007
#include <sstream>         // changed from strstream.h on Oct. 11, 2007
#include <assert.h>
#include "dlist.h"
#include "dlist.cc"
#include "error.h"
#include "dfstream.h"
#include "boolean.h"

class Point
// newRiverV2 Ϥ[ƹ줿ƻ֥ǡ] 򵭲
// Υ饹
{
	long pnum;					// üֹ
	long snum;					// ƻʬֹ
	long newSnum;				// ƻʬֹ
	double x, y, z;				// x,y,z ɸ
	long gx, gy;				// ʻ x,y ɸ

  public:

	long Pnum(void) const { return pnum; }
	void Pnum(long n) { pnum = n; }
	long Snum(void) const { return snum; }
	long NewSnum(void) const { return newSnum; }
	void NewSnum(long n) { newSnum = n; }
	double X(void) const { return x; }
	double Y(void) const { return y; }
	double Z(void) const { return z; }
	long Gx(void) const { return gx; }
	long Gy(void) const { return gy; }

	Point(void) {}
	Point(long p, long s, double xx, double yy, double zz, 
		  long gxx, long gyy)
	{
		pnum = p; snum = s; x = xx; y = yy; z = zz; 
		gx = gxx; gy = gyy;
	}
	Point (const Point & p)
	{
		pnum = p.Pnum(); snum = p.Snum();
		x = p.X(); y = p.Y(); z = p.Z();
		gx = p.Gx(); gy = p.Gy();
	}
};

class Segment
{
	long snum;					// ƻʬֹ
	long numup;					// üֹ
	long numdown;				// üֹ

  public:

	long Snum(void) const { return snum; }
	long Numup(void) const { return numup; }
	void Numup(long n) { numup = n; }
	long Numdown(void) const { return numdown; }
	void Numdown(long n) { numdown = n; }

	Segment(void) {}
	Segment(long s, long u, long d)
	{ snum = s; numup = u; numdown = d; }
	Segment(const Segment & seg)
	{ snum = seg.Snum(); 
	  numup = seg.Numup(); numdown = seg.Numdown(); }
};

class NewSegment
{
	long orgSnum;				// βƻʬֹ
	long num;					// ƻʬο
	long* newSnum;				// ƻʬֹ

  public:

	NewSegment(void) { newSnum = NULL; }
	NewSegment(long o, DList<long> & n);
	~NewSegment(void) { delete [] newSnum; }

	// ƻʬֹ򿷿ƻʬֹ˽񤭴
	void RewriteNumber(DList<long*> & tablist);

	friend ofstream& operator<<(ofstream& os, const NewSegment & s);
};

NewSegment::NewSegment(long o, DList<long> & n)
{
	orgSnum = o;
	num = n.GetCount();
	if (num != 0) newSnum = new long[num];
	else newSnum = NULL;

	int i;
	for (i = 0, n.ToHead(); i < num; i++, n.ToNext())
		newSnum[i] = n.Get();
}

void NewSegment::RewriteNumber(DList<long*> & tablist)
{
	if (num == 0) return;

	for (int i = 0; i < num; i++)
	{
		tablist.ToHead();
		do 
		{
			long* w = tablist.Get();

			// ƻʬֹ򿷿ƻʬֹ˽񤭴
			if (newSnum[i] == w[0])
			{
				newSnum[i] = w[1];
				break;
			}
		}
		while (tablist.ToNext() == YES);
	}
}

ofstream& operator<<
(
  ofstream& os, // ϥȥ꡼
  const NewSegment & s // NewSegment ǡ
)
{
  if (s.num == 0) return os;

  os << s.orgSnum << " " << s.num << " " ;
  for (int i = 0; i < s.num; i++)
    os << s.newSnum[i] << " " ;
  os << endl ;

  return os;
}

/*---------------------------------------------------------------*/
void
OutputPF2Data
(  // ƹPF2 βƻ֤ե˽Ϥ
 long linkNum,
 DList<Point*>& nodeList, // ƻꥹ
 char* ifname, //  PF2 ե̾
 char* ofname  //  PF2 ե̾
)
{

  int gridX = 1, gridY = 1; // ƻ󤬴ޤޤ륰åֹ档٤Ƥ
                            // ĤΥåɤ˴ޤޤΤ 1 1 Ȥ롣
  double riverWidth = 0.0; // ƻǤ 0 Ȥ롣
  char buf[256];

  // ϥե
  ifstream input(ifname);
  if (!input) {
    cerr << "Cannot open " << ifname << endl;
    cerr << "InputPF2" << endl;
    error(); abort();
  }

  // ϥե
  ofstream output(ofname);
  if (!output) {
    cerr << "Cannot open " << ofname << endl;
    cerr << "OutputPF2" << endl;
    error(); abort();
  }

// إåν񤭹
  output << "[Comment]\n"
         << "This data was generated by removeSegment from "
         << ifname << ".\n";

// [Number of End Points] ޤǤ񤭼̤
  input.getline(buf, 256); // 1 ܤɤФ
  while (input.getline(buf, 256)) {
    if (strncmp((const char *)buf, "[Number of End Points]", 22) == 0) {
      break;
    }
    output << buf << "\n";
  }

  input.close();

  // üΥǡθĿΥ
  // Point* EndPoint[] = new Point*[linkNum*2]; // ϥѥ뤬̤ʤäΩ
  Point** EndPoint = new Point*[linkNum*2];
  for (long i=0; i < linkNum*2; i++) {
    EndPoint[i] = (Point*)NULL;  // ɥ쥹 NULL ƽ롣
  }

  nodeList.ToHead();
  while (1) {
    Point* tmpnode = nodeList.Get();
    if (tmpnode->Pnum() > 0) {
       EndPoint[tmpnode->Pnum()] = tmpnode;
    }
    else if (tmpnode->Pnum() < 0) {
       EndPoint[-tmpnode->Pnum()] = tmpnode;
    }
    if (nodeList.ToNext() == NO) break;
  }

  long endPointNum=0;
  for (long i=0; i < linkNum*2; i++) {
    if (EndPoint[i] != (Point*)NULL) {
      endPointNum++;
      // cout << "EndPoint = " << i << " " << EndPoint[i]->Pnum() << endl;
    }
  }
  output << "[Number of End Points]\n"
         << endPointNum << "\n";

  // üΥǡΥե
  long pnumber;
  output << "[Data of End Points]\n";
  for (long i=0; i < linkNum*2; i++) {
    if (EndPoint[i] != (Point*)NULL) {
      if (EndPoint[i]->Pnum() > 0) pnumber = EndPoint[i]->Pnum();
      if (EndPoint[i]->Pnum() < 0) pnumber = -EndPoint[i]->Pnum();
      output << pnumber << " "
             << EndPoint[i]->X() << " "
             << EndPoint[i]->Y() << " "
             << EndPoint[i]->Z() << " "
             << "0" << "\n";
    }
  }

  // ƻΥǡȥե
  output << "[Number of River Segments]\n";
  output << linkNum << "\n";
  output << "[Data]\n";
  nodeList.ToHead();
  while (1) {
    output << gridX  << " "  // åֹ x 
           << gridY  << " "; // åֹ y 
    Point* tmpnode = nodeList.Get();
    if (tmpnode->Pnum() != 0) {
      output << tmpnode->Pnum()    << " "  // üֹ
             << tmpnode->NewSnum() << " "  // ƻʬֹ
             << 0 << " ";                 // ޳԰ֹ
    }
    else {
      output << tmpnode->Pnum() << " "     // üֹ
             << tmpnode->NewSnum() << " "  // ƻʬֹ
             << -1 << " ";                 // ޳԰ֹ
    }
    output << tmpnode->X() << " "        // x ɸ
           << tmpnode->Y() << " "        // y ɸ
           << tmpnode->Z() << " "        // z ɸ
           << riverWidth << "\n";            // ƻ

    if (nodeList.ToNext() == NO) break; // βƻʤФޤ
  }

  output.close();
  return;
}
/*---------------------------------------------------------------*/



int main
(
 int argc,
 char** argv
)
{
  char inewRiverData[256]; char isegNumberData[256];
  char onewRiverData[256]; char osegNumberData[256];
  char inewPF2Data[256]; char onewPF2Data[256];

  if (argc == 1) {
    cout << "# river data (input file) : " ;
    cin >> inewRiverData ;
    cout << "# segment number data (input file) : " ;
    cin >> isegNumberData ;
    cout << "# PF2 river data (input file) : " ;
    cin >> inewPF2Data ;
    cout << "# new river data (output file) : " ;
    cin >> onewRiverData ;
    cout << "# new segment number data (output file) : " ;
    cin >> osegNumberData ;
    cout << "# new PF2 river data (output file) : " ;
    cin >> onewPF2Data ;
  }
  else if (argc == 2) {
    dfstream dfs(argv[1]);
    dfs >> inewRiverData >> isegNumberData >> inewPF2Data
        >> onewRiverData >> osegNumberData >> onewPF2Data;
  }
  else cerr << "Error: bad arguments" << endl;

  // ٤ƻʬõʤ顢ƻΥǡꥹȤ
  // ɤ߹

  DList<Point*> rplist;  // newRiverData ˵ϿƤƻ
                         // Ͽꥹ
  DList<Segment*> seglist; // ٤ƻʬϿꥹ

  dfstream dfsNewRiverData(inewRiverData);
  dfstream dfsSegNumberData(isegNumberData);

  Boolean inFlag = NO; // YES: ƻʬˤ
                       // NO:  ƻʬФ
  Boolean justNow = NO;

  long pnum, snum; double x, y, z; long gx, gy;
  long prevpnum, prevsnum; double prevx, prevy;
  prevpnum = prevsnum = -99999; prevx = prevy = 0.0;

  char buf[256];
  while (dfsNewRiverData.getline(buf, 256)) {
    //istrstream istr(buf);   // comment out Oct. 11, 2007
    istringstream istr((const char*)buf);  // added Oct. 11, 2007
    istr >> pnum >> snum >> x >> y >> z >> gx >> gy ;
    Point* p = new Point(pnum, snum, x, y, z, gx, gy);
    rplist.Append(p);

    // p ϲƻʬμ
    if (justNow == YES) {
      if (pnum == 0) justNow = NO;
      // üΤߤ鹽Ƥƻʬȯ
      else {
      // ٤ƻʬȯ
        if (x == prevx && y == prevy) {
          Segment* seg = new Segment(snum, prevpnum, pnum);
          seglist.Append(seg);
          cout << "Segment " << snum << " must be removed." << endl;
        }
      }
    }

    prevpnum = pnum; prevsnum = snum;
    prevx = x; prevy = y;

    if (pnum != 0) {
      if (inFlag == NO) inFlag = justNow = YES;
      else {
        inFlag = NO;
        prevpnum = prevsnum = -99999;
        prevx = prevy = 0.0;
      }
    }
  }

  if (rplist.GetCount() < 2) {
    cerr << "Error: invalid data." << endl;
    exit(1);
  }

  cout << "work 1 done." << endl;

  // dfsSegNumberData  seglist ˵ϿƤƻʬ
  // ǡơnewSegmentList ˽Ϥ

  // ٤ƻʬʤä
  if (seglist.GetCount() == 0) {
    cout << "No segment removed. Use river data generated by remakeRiverData," << endl;
    rplist.Erase(); seglist.Erase();
    return 0;
  }

  DList<NewSegment*> newSegmentList;

  while (dfsSegNumberData.getline(buf, 256)) {
    long op, num, np;
    //istrstream istr(buf);     // comment out Oct. 11, 2007
    istringstream istr((const char*)buf);    // added Oct. 11, 2007
    istr >> op >> num ;
    DList<long> tmplist;

    for (long i = 0; i < num; i++) {
      istr >> np ;
			seglist.ToHead();
			Boolean flag = NO;
			do 
			{
				Segment* s = seglist.Get();
				if (np == s->Snum())
				{
					flag = YES; 
					break;
				}
			}
			while (seglist.ToNext() == YES);

			if (flag == NO) tmplist.Append(np);
		}

		NewSegment* ns = new NewSegment(op, tmplist);
		newSegmentList.Append(ns);
	}

	if (newSegmentList.GetCount() == 0) 
	{
		cerr << "Error: invalid data.\n" 
			 << "file: " << isegNumberData << endl;
		rplist.Erase(); seglist.Erase();
		exit(1);
	}

	cout << "work 2 done." << endl;

	// rplist  seglist ϿƤƻʬ
	// бüֹ

	do // seglist ˤʤޤǷ֤
	{
		seglist.ToHead();
		Segment* seg = seglist.Get();
		seglist.Delete();
		
 		// rplist פʥǡ
		rplist.ToHead();
		
		// changed by Kato  Jan. 29, 2008
		Boolean nextflag = YES; //Ǥ¸ߤ뤫򼨤
		do 
		{
			Point* p = rplist.Get();
			// ٤ƻʬȯ
			if (p->Snum() == seg->Snum())
			{
				rplist.Delete();
				if(rplist.ToPrev()==NO)// ҤȤäƤ
				{
					nextflag = YES;
					continue; //ξrplist.ToNext()Ф
					//ToNext¹ԤǤҤȤФƤޤȤˤ
				}
			}
			// üֹ
			else if (abs(p->Pnum()) == abs(seg->Numdown()))
			{
				if (p->Pnum() > 0) p->Pnum(abs(seg->Numup()));
				else p->Pnum(-abs(seg->Numup()));
			}
			nextflag = rplist.ToNext(); //doκǸToNext¹Ԥ롼פ³Բǽå
		}
		while (nextflag == YES);
		// changed :end
		
		
		// seglist üֹ⽤
		if (seglist.GetCount() != 0)
		{
			seglist.ToHead();
			do
			{
				Segment* seg2 = seglist.Get();
				if (abs(seg2->Numup()) == abs(seg->Numdown()))
					seg2->Numup(seg->Numup());
				else if (abs(seg2->Numdown()) == abs(seg->Numdown()))
					seg2->Numdown(seg->Numup());
			}
			while (seglist.ToNext() == YES);
		}
	}
	while (seglist.GetCount() != 0);

	// rplist Ƥե˽Ϥ

	ofstream ofsNewRiverData(onewRiverData);
	ofsNewRiverData << "# üֹ ƻʬֹ xɸ yɸ ɸ xʻҺɸ yʻҺɸ)" << endl;

	rplist.ToHead();
  long count = 1;  // ƻʬֹ
	inFlag = NO;
	DList<long*> tablist;
  do
  {
    Point* p = rplist.Get();
    ofsNewRiverData << p->Pnum() << " " << count << " " 
                    << p->X() << " " << p->Y() << " " << p->Z() << " " 
                    << p->Gx() << " " << p->Gy() << endl;

    p->NewSnum(count);
    if (p->Pnum() != 0) { // üξ
      // ƻʬֹȿƻʬֹбϿ
      if (inFlag == NO) {
        inFlag = YES;
        long* w = new long[2];
        w[0] = p->Snum(); w[1] = count;
        tablist.Append(w);
      }
      else {
        inFlag = NO;
        count++;
      }
    }
  }
  while (rplist.ToNext() == YES);

  long LinkNum = count-1;
  cout << "linkNum = " << LinkNum << endl;

	// βƻʬֹȿƻʬֹбե˽Ϥ
	ofstream ofsSegNumberData(osegNumberData);

	newSegmentList.ToHead();
	do 
	{
		NewSegment* s = newSegmentList.Get();
		s->RewriteNumber(tablist);
		ofsSegNumberData << *s ;
	}
	while (newSegmentList.ToNext() == YES);

  // -----  PF2 ƻǡեν -----
  OutputPF2Data(LinkNum, rplist, inewPF2Data, onewPF2Data);

  rplist.Erase();
  seglist.Erase();

  cout << "done." << endl;

  return 0;
}
